#include <kdialog.h>
#include <klocale.h>

/****************************************************************************
** Form implementation generated from reading ui file '/builddir/build/BUILD/kdesvn-0.14.1/src/settings/subversion_settings.ui'
**
** Created by User Interface Compiler
**
** WARNING! All changes made in this file will be lost!
****************************************************************************/

#include "/builddir/build/BUILD/kdesvn-0.14.1/kdesvn-build/src/settings/subversion_settings.h"

#include <qvariant.h>
#include <qcheckbox.h>
#include <knuminput.h>
#include <qlayout.h>
#include <qtooltip.h>
#include <qwhatsthis.h>
#include "knuminput.h"

/*
 *  Constructs a SubversionSettings as a child of 'parent', with the
 *  name 'name' and widget flags set to 'f'.
 */
SubversionSettings::SubversionSettings( QWidget* parent, const char* name, WFlags fl )
    : QWidget( parent, name, fl )
{
    if ( !name )
	setName( "SubversionSettings" );
    SubversionSettingsLayout = new QVBoxLayout( this, 11, 6, "SubversionSettingsLayout"); 

    kcfg_start_updates_check_on_open = new QCheckBox( this, "kcfg_start_updates_check_on_open" );
    SubversionSettingsLayout->addWidget( kcfg_start_updates_check_on_open );

    kcfg_check_needslock = new QCheckBox( this, "kcfg_check_needslock" );
    SubversionSettingsLayout->addWidget( kcfg_check_needslock );

    kcfg_details_on_remote_listing = new QCheckBox( this, "kcfg_details_on_remote_listing" );
    SubversionSettingsLayout->addWidget( kcfg_details_on_remote_listing );

    kcfg_info_recursive = new QCheckBox( this, "kcfg_info_recursive" );
    SubversionSettingsLayout->addWidget( kcfg_info_recursive );

    kcfg_properties_on_remote_items = new QCheckBox( this, "kcfg_properties_on_remote_items" );
    SubversionSettingsLayout->addWidget( kcfg_properties_on_remote_items );

    kcfg_display_ignored_files = new QCheckBox( this, "kcfg_display_ignored_files" );
    SubversionSettingsLayout->addWidget( kcfg_display_ignored_files );

    kcfg_store_passwords = new QCheckBox( this, "kcfg_store_passwords" );
    SubversionSettingsLayout->addWidget( kcfg_store_passwords );

    kcfg_passwords_in_wallet = new QCheckBox( this, "kcfg_passwords_in_wallet" );
    SubversionSettingsLayout->addWidget( kcfg_passwords_in_wallet );

    kcfg_log_follows_nodes = new QCheckBox( this, "kcfg_log_follows_nodes" );
    SubversionSettingsLayout->addWidget( kcfg_log_follows_nodes );

    kcfg_log_always_list_changed_files = new QCheckBox( this, "kcfg_log_always_list_changed_files" );
    SubversionSettingsLayout->addWidget( kcfg_log_always_list_changed_files );

    kcfg_review_commit = new QCheckBox( this, "kcfg_review_commit" );
    SubversionSettingsLayout->addWidget( kcfg_review_commit );

    kcfg_commit_hide_new = new QCheckBox( this, "kcfg_commit_hide_new" );
    SubversionSettingsLayout->addWidget( kcfg_commit_hide_new );

    kcfg_maximum_displayed_logs = new KIntNumInput( this, "kcfg_maximum_displayed_logs" );
    kcfg_maximum_displayed_logs->setMinValue( 0 );
    SubversionSettingsLayout->addWidget( kcfg_maximum_displayed_logs );
    spacer7 = new QSpacerItem( 20, 16, QSizePolicy::Minimum, QSizePolicy::Expanding );
    SubversionSettingsLayout->addItem( spacer7 );
    languageChange();
    resize( QSize(339, 384).expandedTo(minimumSizeHint()) );
    clearWState( WState_Polished );
}

/*
 *  Destroys the object and frees any allocated resources
 */
SubversionSettings::~SubversionSettings()
{
    // no need to delete child widgets, Qt does it all for us
}

/*
 *  Sets the strings of the subwidgets using the current
 *  language.
 */
void SubversionSettings::languageChange()
{
    setCaption( tr2i18n( "Subversion Settings" ) );
    kcfg_start_updates_check_on_open->setText( tr2i18n( "Start check for updates when open a working copy" ) );
    kcfg_start_updates_check_on_open->setAccel( QKeySequence( QString::null ) );
    QToolTip::add( kcfg_start_updates_check_on_open, tr2i18n( "Select if kdesvn should check for updates when open a working copy" ) );
    kcfg_check_needslock->setText( tr2i18n( "Check if items has \"svn:needs-lock\" property set" ) );
    QToolTip::add( kcfg_check_needslock, tr2i18n( "When listing on working copies kdesvn may check for this property" ) );
    QWhatsThis::add( kcfg_check_needslock, tr2i18n( "When listing on working copies kdesvn may check for <tt>svn:needs-lock</tt> property.<br>But due this listings/updating on folders containing lot of items may get slow. So you should only switch on if you have repositories containing lot of such entries." ) );
    kcfg_details_on_remote_listing->setText( tr2i18n( "Get file details while remote listing" ) );
    kcfg_details_on_remote_listing->setAccel( QKeySequence( QString::null ) );
    QToolTip::add( kcfg_details_on_remote_listing, tr2i18n( "Whether getting details about items when making listing on repositories or not" ) );
    QWhatsThis::add( kcfg_details_on_remote_listing, tr2i18n( "<p align=\"left\">When checked, kdesvn get more detailed info about file items when making a listing to remote repositories. So you may see remote locks in overview.\n"
"</p>\n"
"<p align=\"left\"><i>Be careful: This may let listings REAL slow!</i></p>" ) );
    kcfg_info_recursive->setText( tr2i18n( "Gain item info recursive" ) );
    kcfg_info_recursive->setAccel( QKeySequence( QString::null ) );
    kcfg_properties_on_remote_items->setText( tr2i18n( "Always get properties on networked repositories" ) );
    kcfg_properties_on_remote_items->setAccel( QKeySequence( QString::null ) );
    QToolTip::add( kcfg_properties_on_remote_items, tr2i18n( "Should kdesvn retrieves properties on selected item in repositories" ) );
    QWhatsThis::add( kcfg_properties_on_remote_items, tr2i18n( "When browsing kdesvn may try displaying properties below itemlist from a selected item. \n"
"On networked repositories (eg., not opened via file:// protocol) this may get real slow. So if you have slow network connections or when browsing hangs often you should deactivate it." ) );
    kcfg_display_ignored_files->setText( tr2i18n( "Display ignored files" ) );
    kcfg_display_ignored_files->setAccel( QKeySequence( QString::null ) );
    kcfg_store_passwords->setText( tr2i18n( "Store passwords for remote connections" ) );
    kcfg_store_passwords->setAccel( QKeySequence( QString::null ) );
    QToolTip::add( kcfg_store_passwords, tr2i18n( "Should subversion store passwords in default" ) );
    QWhatsThis::add( kcfg_store_passwords, tr2i18n( "Storing passwords is often a security problem. Kdesvn itself doesn't store any passwords, but the subversion itself inside the configuration area of subversion. If this area is readable from others you should not set it, but you may select for single non critical accounts inside the authentication dialog." ) );
    kcfg_passwords_in_wallet->setText( tr2i18n( "Store passwords into KDE Wallet" ) );
    kcfg_passwords_in_wallet->setAccel( QKeySequence( QString::null ) );
    QToolTip::add( kcfg_passwords_in_wallet, tr2i18n( "When saving passwords, do it into KDE wallet instead of subversions storage?" ) );
    QWhatsThis::add( kcfg_passwords_in_wallet, tr2i18n( "<p>Tells if your passwords set in kdesvn should stored into kde wallet instead of simple cleartext storage of subversion.</p>\n"
"<p>This would be a little bit more secure 'cause KDE wallet is (mostly) encrypted with a password. On other hand you must re-enter your passwords with other subversion clients not accessing KDE wallet (eg. svn commandline itself, rapidsvn and so on).</p>\n"
"<p>If you're HOME storage eg. subversions configfolder is on a network drive you should hard think about not storing passwords in a plain text file like subversion does but put it into an encrypted storage like kde wallet or don't save passwords.</p>" ) );
    kcfg_log_follows_nodes->setText( tr2i18n( "Log follows node changes" ) );
    kcfg_log_follows_nodes->setAccel( QKeySequence( QString::null ) );
    kcfg_log_always_list_changed_files->setText( tr2i18n( "Logs always reads list of changed files" ) );
    kcfg_log_always_list_changed_files->setAccel( QKeySequence( QString::null ) );
    QToolTip::add( kcfg_log_always_list_changed_files, tr2i18n( "Read detailed change lists" ) );
    QWhatsThis::add( kcfg_log_always_list_changed_files, tr2i18n( "Reading lists of changed files may sometimes a little bit slow down things. But if this feature is switched off, kdesvn may fail generating differences between nodechanges from within the logviewer." ) );
    kcfg_review_commit->setText( tr2i18n( "Review items before commit" ) );
    kcfg_review_commit->setAccel( QKeySequence( QString::null ) );
    QToolTip::add( kcfg_review_commit, tr2i18n( "List items next commit will send or not" ) );
    kcfg_commit_hide_new->setText( tr2i18n( "Hide new items in commit box" ) );
    kcfg_commit_hide_new->setAccel( QKeySequence( QString::null ) );
    QToolTip::add( kcfg_commit_hide_new, tr2i18n( "Should unversioned items displayed in commit dialog or not." ) );
    kcfg_maximum_displayed_logs->setLabel( tr2i18n( "Maximum displayed logs when full log (0 for no limit)" ) );
}

